> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# Retrieve a bill run

GET https://rest.test.zuora.com/v1/bill-runs/{billRunId}

Retrieves the information about a specific bill run.


Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/bill-runs/bill-run/get-bill-run

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Path parameters

- `billRunId` (string, required) — The unique ID of a bill run.

### Headers

- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.
- `Zuora-Version` (string, optional) — The minor API version. For a list of available minor versions, see [API upgrades](https://developer.zuora.com/v1-api-reference/api-upgrades/).

## Response

### 200

OK

- `autoEmail` (boolean, optional) — Whether to automatically send emails after Auto-Post is complete.
- `autoPost` (boolean, optional) — Whether to automatically post the bill run after the bill run is created.
- `autoRenewal` (boolean, optional) — Whether to automatically renew auto-renew subscriptions that are up for renewal.
- `batches` (list of string, optional) — The batch of accounts for this bill run, this field can not exist with `billRunFilters` together. **Values:** `AllBatches` or an array of `Batch`*n* where *n* is a number between 1 and 50, for example, `Batch7`.
- `billCycleDay` (string, optional) — The day of the bill cycle, this field is only valid when `batches` is specified. **Values:** - `AllBillCycleDays` or one of numbers 1 - 31 for an ad-hoc bill run - `AllBillCycleDays`, one of numbers 1 - 31, or `AsRunDay` for a scheduled bill run
- `billRunFilters` (list of BillRunFilterResponseType, optional) — The target account, subscriptions, invoice schedule, or a combination of objects for this bill run. You can only specify either this field or the `batches` field.
- `billRunNumber` (string, optional) — The number of the bill run.
- `chargeTypeToExclude` (list of enum, optional) — The types of the charges to be excluded from the generation of billing documents.
  - Allowed values: `OneTime`, `Recurring`, `Usage`
- `createdById` (string, optional) — The ID of the user who created the bill run.
- `createdDate` (string, optional) — The date and time when the bill run was created.
- `includeSubscriptions` (boolean, optional, default: true) — Indicates whether to bill subscriptions in the bill run.
- `includeOrderLineItems` (boolean, optional, default: true) — Indicates whether to bill order line items in the bill run.
- `id` (string, optional) — The unqie ID of the bill run.
- `invoiceDate` (date, optional) — The invoice date for this bill run, only valid for ad-hoc bill runs.
- `invoiceDateOffset` (integer, optional) — The offset compared to bill run execution date, only valid for scheduled bill runs.
- `invoiceDateMonthOffset` (integer, optional) — The month offset of invoice date for this bill run compared to bill run execution date. **Note**: This field is only valid when the `repeatType` field is set to `Monthly`. When using the `invoiceDateMonthOffset` and `invoiceDateDayOfMonth` fields, do not use the `invoiceDateOffset` field, and vice versa.
- `invoiceDateDayOfMonth` (integer, optional) — The day of month of invoice date for this bill run. Specify a day of the month. If you specify 31, even though the month doesn't have 31, for example, February or April, the date recurs on the end day of each scheduled month. **Note**: This field is only valid when the `repeatType` field is set to `Monthly`. When using the `invoiceDateMonthOffset` and `invoiceDateDayOfMonth` fields, do not use the `invoiceDateOffset` field, and vice versa.
- `name` (string, optional) — The name of the bill run.
- `noEmailForZeroAmountInvoice` (boolean, optional) — Whether to suppress emails for invoices with zero total amount generated in this bill run after the bill run is complete.
- `organizationLabels` (list of GetBillRunResponseTypeOrganizationLabelsItems, optional) — The organization(s) that the run is created for. Note: This field is available only when the Multi-Org feature is enabled.
- `schedule` (BillRunScheduleResponseType, optional) — Container for information about the scheduled bill run.
- `scheduledExecutionTime` (string, optional) — The scheduled execution time for a bill run.
- `status` (enum, optional) — The status of the bill run.
  - Allowed values: `Pending`, `Processing`, `Completed`, `Error`, `Canceled`, `Posted`, `PostInProgress`, `CancelInProgress`, `RemoveInProgress`, `Paused`
- `targetDate` (date, optional) — The target date for this bill run, only valid for ad-hoc bill runs.
- `targetDateOffset` (integer, optional) — The offset compared to bill run execution date, only valid for scheduled bill runs.
- `targetDateMonthOffset` (integer, optional) — The month offset of target date for this bill run compared to bill run execution date. **Note**: This field is only valid when the `repeatType` field is set to `Monthly`. When using the `targetDateMonthOffset` and `targetDateDayOfMonth` fields, do not use the `targetDateOffset` field, and vice versa.
- `targetDateDayOfMonth` (integer, optional) — The day of month of target date for this bill run. Specify a day of the month. If you specify 31, even though the month doesn't have 31, for example, February or April, the date recurs on the end day of each scheduled month. **Note**: This field is only valid when the `repeatType` field is set to `Monthly`. When using the `targetDateMonthOffset` and `targetDateDayOfMonth` fields, do not use the `targetDateOffset` field, and vice versa.
- `updatedById` (string, optional) — The ID of the user who last updated the bill run.
- `updatedDate` (string, optional) — The date and time when the bill run was last updated.

## Errors

### 500 Internal Server Error

Internal Server Error

- `reasons` (list of ErrorResponseReasonsItems, optional)

### 400 Client Request Error

Request Errors

- `processId` (string, optional) — The ID of the process that handles the operation.
- `reasons` (list of CommonResponseReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (string, optional) — Unique identifier of the request.
- `success` (boolean, optional) — Indicates whether the call succeeded.

## Types

### BillRunFilterResponseType

- `accountId` (string, optional) — The target account of the bill run.
- `filterType` (enum, optional) — To create bill runs based on the selected filter type: * `Account`: Create bill runs by account. * `Subscription`: Create bill runs by subscription, you must specify the `subscriptionId` field. * `InvoiceSchedule`: Create a scheduled bill run, you must specify the schedule field. See Manage scheduled bill runs. * `FilterCondition`: Create bill runs by custom filter combining the Account, Subscription, and Rate Plan objects, you must specify the `condition` and `objectType` fields. See Bill Run Advanced Filter.
  - Allowed values: `Account`, `Subscription`, `InvoiceSchedule`, `FilterCondition`
- `condition` (Condition, optional) — Container for condition information about the Bill Run Advanced Filter.
- `objectType` (enum, optional) — The target object type of the condition when the `filterType` field is specified as `FilterCondition`. See Bill Run Advanced Filter.
  - Allowed values: `Account`, `Subscription`, `RatePlanCharge`
- `subscriptionId` (string, optional) — The target subscripiton ID of the account.

### GetBillRunResponseTypeOrganizationLabelsItems

- `organizationId` (string, optional) — The organization ID.
- `organizationName` (string, optional) — The organization name.

### BillRunScheduleResponseType

Container for information about the scheduled bill run.

- `repeatFrom` (date, optional) — The start date of the scheduled bill run.
- `repeatTo` (date, optional) — The end date of of the scheduled bill run.
- `repeatType` (enum, optional) — The repeat type of the bill run.
  - Allowed values: `None`, `Daily`, `Weekly`, `Monthly`
- `runTime` (integer, optional) — The scheduled run time (hour) of day. **Values:** 0 - 23
- `weeklyOnDay` (list of enum, optional) — The repeat day in a week.
  - Allowed values: `Mon`, `Tue`, `Wed`, `Thu`, `Fri`, `Sat`, `Sun`
- `monthlyOnEndOfMonth` (boolean, optional) — Whether to schedule monthly bill run on the end of month or the specific day of month. **Note**: This field is available only when the `repeatType` field is set to `Monthly` and the `repeatFrom` field is set to the end of month. For example: - When repeatFrom = `2024-04-30` and monthlyOnEndOfMonth = `true`, next bill run will be scheduled on `2024-05-31`. - When repeatFrom = `2024-04-30` and monthlyOnEndOfMonth = `false`, next bill run will be scheduled on `2024-05-30`.

### ErrorResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

### CommonResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

### Condition

Container for condition information about the Bill Run Advanced Filter.

- `conditions` (list of Condition, optional) — Multiple `conditions` fields are combined by the `relation` fields. These `conditions` fields form a custom filter. Each `conditions` field is a formula combined by the `field`, `operator`, and `value` fields. See Common use cases of Bill Run Advanced Filter.
- `field` (string, optional) — The field name of a single condition that is indicated by the `conditions` field.
- `operator` (enum, optional) — The operator of a single condition that is indicated by the `conditions` field. The operator is added between the `field` and `value` fields. * eq: equal (`field` = `value`) * neq: not equal (`field` != `value`) * gt: greater than (`field` > `value`) * lt: less than (`field` \< `value`) * gte: greater than or equal (`field` >= `value`) * lte: less than or equal (`field` \<= `value`) * lk: like (`field` like `value`) * in: in (`field` in `value`, the values are separated by comma) * nl: null (`field` is null) * nnl: not null (`field` is not null)
  - Allowed values: `eq`, `neq`, `gt`, `lt`, `gte`, `lte`, `lk`, `in`, `nl`, `nnl`
- `relation` (enum, optional) — The relation among the `conditions` fields.
  - Allowed values: `and`, `or`
- `value` (string, optional) — The value or list of values to compare against, depending on the operator. For most operators (for example, `eq`, `lt`, `gt`), `value` contains a single literal value or a supported built-in variable. When you use the `in` operator in an Advanced Filter, `value` must be a comma-separated list with no more than 500 values. If more than 500 values are provided, the API returns a validation error and the Bill Run is not started. This limit applies only to the `in` operator and does not affect the total number of accounts or subscriptions a Bill Run can process. When `filterType` is set to `FilterCondition`, you can provide either: * A literal value (for example, `"15"`), or * A built-in variable in the format `{{VariableName}}`. Built-in variables are supported only in the `value` field of date-type conditions and are resolved at runtime: * `{{Today}}`: Current date in `yyyy-MM-dd` format. * `{{BillRunDate}}`: Bill run execution date in `yyyy-MM-dd` format. * `{{TargetDate}}`: Bill run target date in `yyyy-MM-dd` format. * `{{InvoiceDate}}`: Bill run invoice date in `yyyy-MM-dd` format. Example: `"value": "{{BillRunDate}}"` Built‑in variable for Bill Cycle Day: * `{{AsRunDay}}`: * The day of the month from the bill run execution date, formatted for Bill Cycle Day (BCD) matching. * You must use this variable only with the `BillCycleDay` field of the `Account` object.

## Examples

**Response**

```json
{
  "autoEmail": false,
  "autoPost": false,
  "autoRenewal": false,
  "batches": [
    "AllBatches"
  ],
  "billCycleDay": "AllBillCycleDays",
  "billRunFilters": [
    {
      "filterType": "FilterCondition",
      "condition": {
        "conditions": [
          {
            "conditions": [],
            "field": "billRunEffectiveDate__c",
            "operator": "lte",
            "relation": null,
            "value": "{{InvoiceDate}}"
          }
        ],
        "relation": "and"
      },
      "objectType": "Subscription",
      "invoiceScheduleId": null,
      "invoiceScheduleItemId": null
    }
  ],
  "billRunNumber": "BR-00007954",
  "createdById": "e1187a1f28c8487ca6b40c40ffb10853",
  "createdDate": "2026-01-14 04:31:20",
  "includeSubscriptions": true,
  "includeOrderLineItems": true,
  "id": "8a90ff929bb9d7c0019bbc7d34ec2c5f",
  "invoiceDate": "2025-06-01",
  "name": "Bill subscriptions matched the dynamic invoice date 2025-06-01",
  "noEmailForZeroAmountInvoice": false,
  "status": "Pending",
  "targetDate": "2025-06-01",
  "updatedById": "e1187a1f28c8487ca6b40c40ffb10853",
  "updatedDate": "2026-01-14 04:31:20",
  "success": true
}
```

**SDK Code**

```python
import requests

url = "https://rest.test.zuora.com/v1/bill-runs/billRunId"

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers)

print(response.json())
```

```javascript
const url = 'https://rest.test.zuora.com/v1/bill-runs/billRunId';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/v1/bill-runs/billRunId"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/v1/bill-runs/billRunId")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://rest.test.zuora.com/v1/bill-runs/billRunId")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://rest.test.zuora.com/v1/bill-runs/billRunId', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/v1/bill-runs/billRunId");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/v1/bill-runs/billRunId")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```